package com.gree.mall.manager.logic.settle.repair;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gree.mall.manager.bean.admin.AdminUserCom;
import com.gree.mall.manager.bean.settle.repair.DailyWithholdVO;
import com.gree.mall.manager.commonmapper.CommonMapper;
import com.gree.mall.manager.exception.RemoteServiceException;
import com.gree.mall.manager.logic.common.CommonLogic;
import com.gree.mall.manager.plus.entity.SettleDailyWithhold;
import com.gree.mall.manager.plus.service.SettleDailyWithholdService;
import com.gree.mall.manager.zfire.bean.ZfireParamBean;
import com.gree.mall.manager.zfire.util.FieldUtils;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Service
@Slf4j
@RequiredArgsConstructor
public class DailyWithholdLogic {

    private final CommonLogic commonLogic;
    private final CommonMapper commonMapper;
    private final SettleDailyWithholdService settleDailyWithholdService;

    public IPage<DailyWithholdVO> page(ZfireParamBean zfireParamBean) {
        AdminUserCom adminUser = commonLogic.getAdminUser();
        FieldUtils.supplyParam(zfireParamBean, DailyWithholdVO.class, adminUser);

        return commonMapper.repairSettleDailyWithholdList(new Page(zfireParamBean.getPageNum(), zfireParamBean.getPageSize()), zfireParamBean);
    }

    public SettleDailyWithhold detail(String id) {
        return settleDailyWithholdService.getById(id);
    }

    public void add(SettleDailyWithhold dailyWithhold) {
        AdminUserCom adminUser = commonLogic.getAdminUser();

        if (adminUser.getType() == 2) {
            throw new RemoteServiceException("平台账号禁止操作");
        }

        dailyWithhold.setCompanyWechatId(adminUser.getAdminCompanyWechat().getCompanyWechatId())
                .setCompanyWechatName(adminUser.getAdminCompanyWechat().getCompanyName())
                .insert();
    }


    public void update(SettleDailyWithhold dailyWithhold) {
        dailyWithhold.updateById();
    }


    public void delete(String id) {
        settleDailyWithholdService.removeById(id);
    }
}
